/*
CREATED		12;05;2008
MODIFIED		12;05;2008
PROJECT		
MODEL		
COMPANY		
AUTHOR		
VERSION		
DATABASE		ORACLE 10G 
*/


-- CREATE TYPES SECTION


-- CREATE TABLES SECTION
CREATE TABLE hibernate_sequences (
  SEQUENCE_NAME VARCHAR2(200) NOT NULL,
  NEXT_VAL INTEGER NOT NULL,
  PRIMARY KEY (SEQUENCE_NAME)
)

;

CREATE TABLE SBI_CHECKS (
	CHECK_ID INTEGER NOT NULL ,
	DESCR VARCHAR2 (160),
	LABEL VARCHAR2 (20) NOT NULL ,
	VALUE_TYPE_CD VARCHAR2 (20) NOT NULL ,
	VALUE_TYPE_ID INTEGER NOT NULL ,
	VALUE_1 VARCHAR2 (400),
	VALUE_2 VARCHAR2 (400),
	NAME VARCHAR2 (40) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_CHECKS UNIQUE (LABEL, ORGANIZATION),
PRIMARY KEY (CHECK_ID) 
) 
;
CREATE TABLE SBI_DOMAINS (
	VALUE_ID INTEGER NOT NULL ,
	VALUE_CD VARCHAR2 (100),
	VALUE_NM VARCHAR2 (40),
	DOMAIN_CD VARCHAR2 (20),
	DOMAIN_NM VARCHAR2 (40),
	VALUE_DS VARCHAR2 (160),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_DOMAINS UNIQUE (VALUE_CD, DOMAIN_CD),
PRIMARY KEY (VALUE_ID) 
)  
;

CREATE TABLE SBI_ENGINES (
	ENGINE_ID INTEGER NOT NULL ,
	ENCRYPT SMALLINT,
	NAME VARCHAR2 (40) NOT NULL ,
	DESCR VARCHAR2 (160),
	MAIN_URL VARCHAR2 (400),
	SECN_URL VARCHAR2 (400),
	OBJ_UPL_DIR VARCHAR2 (400),
	OBJ_USE_DIR VARCHAR2 (400),
	DRIVER_NM VARCHAR2 (400),
	LABEL VARCHAR2 (40) NOT NULL ,
	ENGINE_TYPE INTEGER NOT NULL ,
	CLASS_NM VARCHAR2 (400),
	BIOBJ_TYPE INTEGER NOT NULL ,
	DEFAULT_DS_ID INTEGER,
	USE_DATASOURCE SMALLINT DEFAULT 0,
	USE_DATASET SMALLINT DEFAULT 0,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_ENGINES UNIQUE (LABEL, ORGANIZATION),
PRIMARY KEY (ENGINE_ID) 
) 
;

CREATE TABLE SBI_AUDIT (
	ID INTEGER NOT NULL ,
	USERNAME VARCHAR2 (40) NOT NULL ,
	USERGROUP VARCHAR2 (100),
	DOC_REF INTEGER,
	DOC_ID INTEGER,
	DOC_LABEL VARCHAR2 (20) NOT NULL ,
	DOC_NAME VARCHAR2 (40) NOT NULL ,
	DOC_TYPE VARCHAR2 (20) NOT NULL ,
	DOC_STATE VARCHAR2 (20) NOT NULL ,
	DOC_PARAMETERS VARCHAR2 (4000),
	SUBOBJ_REF INTEGER,
	SUBOBJ_ID INTEGER,
	SUBOBJ_NAME VARCHAR2 (50),
	SUBOBJ_OWNER VARCHAR2 (50),
	SUBOBJ_ISPUBLIC SMALLINT,
	ENGINE_REF INTEGER,
	ENGINE_ID INTEGER,
	ENGINE_LABEL VARCHAR2 (40) NOT NULL ,
	ENGINE_NAME VARCHAR2 (40) NOT NULL ,
	ENGINE_TYPE VARCHAR2 (20) NOT NULL ,
	ENGINE_URL VARCHAR2 (400),
	ENGINE_DRIVER VARCHAR2 (400),
	ENGINE_CLASS VARCHAR2 (400),
	REQUEST_TIME TIMESTAMP(6) NOT NULL ,
	EXECUTION_START DATE,
	EXECUTION_END DATE,
	EXECUTION_TIME INTEGER,
	EXECUTION_STATE VARCHAR2 (20),
	ERROR SMALLINT,
	ERROR_MESSAGE VARCHAR2 (400),
	ERROR_CODE VARCHAR2 (20),
	EXECUTION_MODALITY VARCHAR2 (40),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ID) 
) 
;

CREATE TABLE SBI_ACTIVITY_MONITORING (
  ID INTEGER NOT NULL,
  ACTION_TIME TIMESTAMP,
  USERNAME 	 	VARCHAR2(40) NOT NULL,
  USERGROUP		VARCHAR2(400),
  LOG_LEVEL 	VARCHAR2(10) ,
  ACTION_CODE 	VARCHAR2(45) NOT NULL,
  INFO 			VARCHAR2(400),
  PRIMARY KEY (ID)
) 
;

CREATE TABLE SBI_BINARY_CONTENTS (
	BIN_ID INTEGER NOT NULL ,
	BIN_CONTENT BLOB NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (BIN_ID) 
)  
;


CREATE TABLE SBI_DATA_SET (
	   DS_ID 		   		  INTEGER NOT NULL ,
	   VERSION_NUM	   		  INTEGER NOT NULL,
	   ACTIVE		   		  SMALLINT NOT NULL,
	   DESCR 		   		  VARCHAR2(160), 
	   LABEL	 	   		  VARCHAR2(50) NOT NULL,
	   NAME	   	   			  VARCHAR2(50) NOT NULL,   	   
	   OBJECT_TYPE   		  VARCHAR2(50),
	   DS_METADATA    		  CLOB,
	   PARAMS         		  VARCHAR2(4000),
	   CATEGORY_ID    		  INTEGER,
	   TRANSFORMER_ID 		  INTEGER,
       PIVOT_COLUMN   		  VARCHAR2(50),
	   PIVOT_ROW      		  VARCHAR2(50),
	   PIVOT_VALUE   		  VARCHAR2(50),
	   NUM_ROWS	   		 	  SMALLINT DEFAULT 0,	
	   IS_PERSISTED  		  SMALLINT DEFAULT 0,
	   DATA_SOURCE_PERSIST_ID INTEGER NULL,
	   IS_FLAT_DATASET 		  SMALLINT DEFAULT 0,
	   FLAT_TABLE_NAME 		  VARCHAR2(50) NULL,
	   DATA_SOURCE_FLAT_ID 	  INTEGER NULL,	   
	   CONFIGURATION          CLOB NULL,    	   	   
	   OWNER 				  VARCHAR2(50),
	   IS_PUBLIC 			  SMALLINT DEFAULT 0,
	   USER_IN                VARCHAR2(100) NOT NULL,
	   USER_UP                VARCHAR2(100),
	   USER_DE                VARCHAR2(100),
	   TIME_IN                TIMESTAMP NOT NULL,
	   TIME_UP                TIMESTAMP NULL,
	   TIME_DE                TIMESTAMP NULL,
	   SBI_VERSION_IN         VARCHAR2(10),
	   SBI_VERSION_UP         VARCHAR2(10),
	   SBI_VERSION_DE         VARCHAR2(10),
	   META_VERSION           VARCHAR2(100),
	   ORGANIZATION           VARCHAR2(20), 
     CONSTRAINT XAK1SBI_DATA_SET UNIQUE (LABEL,VERSION_NUM, ORGANIZATION),
     PRIMARY KEY (DS_ID, VERSION_NUM)
) 
;


CREATE TABLE SBI_DATA_SOURCE (
	DS_ID INTEGER NOT NULL ,
	DESCR VARCHAR2 (160),
	LABEL VARCHAR2 (50) NOT NULL ,
	JNDI VARCHAR2 (50),
	URL_CONNECTION VARCHAR2 (500),
	USERNAME VARCHAR2 (50),
	PWD VARCHAR2 (50),
	DRIVER VARCHAR2 (160),
	DIALECT_ID INTEGER NOT NULL ,
    MULTI_SCHEMA NUMBER(38,0) DEFAULT 0,
	ATTR_SCHEMA VARCHAR2(45) DEFAULT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_DATA_SOURCE UNIQUE (LABEL, ORGANIZATION),
PRIMARY KEY (DS_ID) 
) 
;

CREATE TABLE SBI_DIST_LIST (
	DL_ID INTEGER NOT NULL ,
	NAME VARCHAR2 (40) NOT NULL ,
	DESCR VARCHAR2 (160),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_SBI_DIST_LIST UNIQUE (NAME, ORGANIZATION),
PRIMARY KEY (DL_ID) 
) 
;

CREATE TABLE SBI_DIST_LIST_USER (
	DLU_ID INTEGER NOT NULL ,
	LIST_ID INTEGER NOT NULL ,
	USER_ID VARCHAR2 (40) NOT NULL ,
	E_MAIL VARCHAR2 (70) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (DLU_ID) 
) 
;

CREATE TABLE SBI_DIST_LIST_OBJECTS (
	REL_ID INTEGER NOT NULL ,
	DOC_ID INTEGER NOT NULL ,
	DL_ID INTEGER NOT NULL ,
	XML VARCHAR2 (4000) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (REL_ID) 
) 
;



CREATE TABLE SBI_DOSSIER_BIN_TEMP (
	BIN_ID INTEGER NOT NULL ,
	PART_ID INTEGER NOT NULL ,
	NAME VARCHAR2 (20),
	BIN_CONTENT BLOB NOT NULL ,
	TYPE VARCHAR2 (20) NOT NULL ,
	CREATION_DATE TIMESTAMP(6) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (BIN_ID) 
)  
;

CREATE TABLE SBI_DOSSIER_TEMP (
	PART_ID INTEGER NOT NULL ,
	WORKFLOW_PROCESS_ID DOUBLE PRECISION NOT NULL ,
	BIOBJ_ID INTEGER NOT NULL ,
	PAGE_ID INTEGER NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (PART_ID) 
) 
;

CREATE TABLE SBI_DOSSIER_PRES (
	PRESENTATION_ID INTEGER NOT NULL ,
	WORKFLOW_PROCESS_ID DOUBLE PRECISION NOT NULL ,
	BIOBJ_ID INTEGER NOT NULL ,
	BIN_ID INTEGER NOT NULL ,
	NAME VARCHAR2 (40) NOT NULL ,
	PROG INTEGER,
	CREATION_DATE TIMESTAMP(6) NOT NULL ,
	APPROVED SMALLINT,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (PRESENTATION_ID) 
) 
;

CREATE TABLE SBI_EVENTS (
	ID INTEGER NOT NULL ,
	USER_EVENT VARCHAR2 (40) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ID) 
) 
;

CREATE TABLE SBI_EVENTS_LOG (
	ID INTEGER NOT NULL ,
	USER_EVENT VARCHAR2 (40) NOT NULL ,
	EVENT_DATE DATE NOT NULL ,
	DESCR VARCHAR2 (4000) NOT NULL ,
	PARAMS VARCHAR2 (1000),
	HANDLER VARCHAR2 (400) DEFAULT 'IT.ENG.SPAGOBI.EVENTS.HANDLERS.DEFAULTEVENTPRESENTATIONHANDLER' NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
	PRIMARY KEY (ID) 
)  
;

CREATE TABLE SBI_EVENTS_ROLES (
	EVENT_ID INTEGER NOT NULL ,
	ROLE_ID INTEGER NOT NULL ,
PRIMARY KEY (EVENT_ID,ROLE_ID) 
)  
;

CREATE TABLE SBI_EXT_ROLES (
	EXT_ROLE_ID NUMBER(38,0) CONSTRAINT "SYS_C0011867" NOT NULL ,
	NAME 					VARCHAR2 (100) NOT NULL,
	DESCR 					VARCHAR2 (160),
	CODE 					VARCHAR2 (20),
	ROLE_TYPE_CD 			VARCHAR2 (20) CONSTRAINT "SYS_C0011868" NOT NULL ,
	ROLE_TYPE_ID 			NUMBER(38,0) CONSTRAINT "SYS_C0011869" NOT NULL ,
	SEE_SUBOBJECTS 			SMALLINT DEFAULT 1,
	SEE_VIEWPOINTS 			SMALLINT DEFAULT 1,
	SEE_SNAPSHOTS 			SMALLINT DEFAULT 1,
	SEE_NOTES 				SMALLINT DEFAULT 1,
	SEND_MAIL 				SMALLINT DEFAULT 1,
	SAVE_INTO_FOLDER 		SMALLINT DEFAULT 1,
	SAVE_REMEMBER_ME 		SMALLINT DEFAULT 1,
	SEE_METADATA 			SMALLINT DEFAULT 1,
	SAVE_METADATA 			SMALLINT DEFAULT 1,
	SAVE_SUBOBJECTS 		SMALLINT DEFAULT 1,
	BUILD_QBE_QUERY 		SMALLINT DEFAULT 1,
	DO_MASSIVE_EXPORT 		SMALLINT DEFAULT 1,
	EDIT_WORKSHEET 		 	SMALLINT DEFAULT 1,
	MANAGE_USERS  			SMALLINT DEFAULT 0,
	SEE_DOCUMENT_BROWSER 	SMALLINT DEFAULT 1,
	SEE_FAVOURITES 		 	SMALLINT DEFAULT 1,
	SEE_SUBSCRIPTIONS	 	SMALLINT DEFAULT 1,
	SEE_MY_DATA 		 	SMALLINT DEFAULT 1,
	SEE_TODO_LIST 		 	SMALLINT DEFAULT 1,
	CREATE_DOCUMENTS	 	SMALLINT DEFAULT 1,
	USER_IN              	VARCHAR2(100) NOT NULL,
    USER_UP              	VARCHAR2(100),
    USER_DE              	VARCHAR2(100),
    TIME_IN              	TIMESTAMP NOT NULL,
    TIME_UP              	TIMESTAMP DEFAULT NULL,    
    TIME_DE              	TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       	VARCHAR2(10),
    SBI_VERSION_UP       	VARCHAR2(10),
    SBI_VERSION_DE       	VARCHAR2(10),
    META_VERSION         	VARCHAR2(100),
    ORGANIZATION         	VARCHAR2(20),
	CONSTRAINT XAK1SBI_EXT_ROLES UNIQUE (NAME, ORGANIZATION),
PRIMARY KEY (EXT_ROLE_ID) 
) 
;

CREATE TABLE SBI_FUNC_ROLE (
	FUNCT_ID INTEGER NOT NULL ,
	STATE_ID INTEGER NOT NULL ,
	ROLE_ID INTEGER NOT NULL ,
	STATE_CD VARCHAR2 (20),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (FUNCT_ID,STATE_ID,ROLE_ID) 
) 
;

CREATE TABLE SBI_FUNCTIONS (
	FUNCT_ID INTEGER NOT NULL ,
	FUNCT_TYPE_CD VARCHAR2 (20) NOT NULL ,
	PARENT_FUNCT_ID INTEGER,
	NAME VARCHAR2 (40),
	DESCR VARCHAR2 (160),
	PATH VARCHAR2 (400),
	CODE VARCHAR2 (40) NOT NULL ,
	PROG INTEGER NOT NULL ,
	FUNCT_TYPE_ID INTEGER NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
CONSTRAINT XAK1SBI_FUNCTIONS UNIQUE (CODE, ORGANIZATION),	
PRIMARY KEY (FUNCT_ID) 
) 
;

CREATE TABLE SBI_GEO_FEATURES (
	FEATURE_ID INTEGER NOT NULL ,
	NAME VARCHAR2 (40) NOT NULL ,
	DESCR VARCHAR2 (160),
	TYPE VARCHAR2 (40),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_GEO_FEATURES UNIQUE (NAME, ORGANIZATION),
PRIMARY KEY (FEATURE_ID) 
) 
;

CREATE TABLE SBI_GEO_MAP_FEATURES (
	MAP_ID INTEGER NOT NULL ,
	FEATURE_ID INTEGER NOT NULL ,
	SVG_GROUP VARCHAR2 (40),
	VISIBLE_FLAG VARCHAR2 (1),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (MAP_ID,FEATURE_ID) 
) 
;

CREATE TABLE SBI_GEO_MAPS (
	MAP_ID INTEGER NOT NULL ,
	NAME VARCHAR2 (40) NOT NULL ,
	DESCR VARCHAR2 (160),
	URL VARCHAR2 (400) ,
	FORMAT VARCHAR2 (40),
	BIN_ID INTEGER,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_GEO_MAPS UNIQUE (NAME, ORGANIZATION),
PRIMARY KEY (MAP_ID) 
) 
;

CREATE TABLE SBI_LOV (
	LOV_ID INTEGER NOT NULL ,
	DESCR VARCHAR2 (160),
	LABEL VARCHAR2 (20) NOT NULL ,
	INPUT_TYPE_CD VARCHAR2 (20) NOT NULL ,
	DEFAULT_VAL VARCHAR2 (40),
	LOV_PROVIDER CLOB ,
	INPUT_TYPE_ID INTEGER NOT NULL ,
	PROFILE_ATTR VARCHAR2 (20),
	NAME VARCHAR2 (40) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    DATASET_ID			 INTEGER,
    CONSTRAINT XAK1SBI_LOV UNIQUE (LABEL, ORGANIZATION),
PRIMARY KEY (LOV_ID) 
) 
;


CREATE TABLE SBI_MENU (
		MENU_ID INTEGER NOT NULL,
		NAME VARCHAR2(50), 
		DESCR VARCHAR2(2000),
		PARENT_ID INTEGER DEFAULT 0, 
		BIOBJ_ID INTEGER,
		VIEW_ICONS SMALLINT DEFAULT 0,
		HIDE_TOOLBAR SMALLINT DEFAULT 0, 
		HIDE_SLIDERS SMALLINT DEFAULT 0,
		STATIC_PAGE VARCHAR2(45),
		BIOBJ_PARAMETERS CLOB NULL,
		SUBOBJ_NAME VARCHAR2(50) NULL,
		SNAPSHOT_NAME VARCHAR2(100) NULL,
		SNAPSHOT_HISTORY INTEGER NULL,
		FUNCTIONALITY VARCHAR2(50) NULL,
		INITIAL_PATH VARCHAR2(400) NULL,
		EXT_APP_URL VARCHAR2(1000) NULL,
		PROG INTEGER  DEFAULT 1 NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (MENU_ID)
) 
;

CREATE TABLE SBI_MENU_ROLE (
       MENU_ID INTEGER NOT NULL, 
       EXT_ROLE_ID INTEGER NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (MENU_ID, EXT_ROLE_ID)
) 
;

CREATE TABLE SBI_OBJ_FUNC (
	BIOBJ_ID INTEGER NOT NULL ,
	FUNCT_ID INTEGER NOT NULL ,
	PROG INTEGER,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (BIOBJ_ID,FUNCT_ID) 
) 
;

CREATE TABLE SBI_OBJ_PAR (
	OBJ_PAR_ID INTEGER NOT NULL ,
	PAR_ID INTEGER NOT NULL ,
	BIOBJ_ID INTEGER NOT NULL ,
	LABEL VARCHAR2 (40) NOT NULL ,
	REQ_FL SMALLINT,
	MOD_FL SMALLINT,
	VIEW_FL SMALLINT,
	MULT_FL SMALLINT,
	PROG INTEGER NOT NULL ,
	PARURL_NM VARCHAR2 (20),
	PRIORITY INTEGER,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (OBJ_PAR_ID) 
) 
;

CREATE TABLE SBI_OBJ_PARUSE (
	OBJ_PAR_ID INTEGER NOT NULL ,
	USE_ID INTEGER NOT NULL ,
	OBJ_PAR_FATHER_ID INTEGER NOT NULL ,
	FILTER_OPERATION VARCHAR2 (20) NOT NULL ,
	PROG INTEGER NOT NULL ,
	FILTER_COLUMN VARCHAR2 (30) NOT NULL ,
	PRE_CONDITION VARCHAR2 (10),
	POST_CONDITION VARCHAR2 (10),
	LOGIC_OPERATOR VARCHAR2 (10),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (OBJ_PAR_ID,USE_ID,OBJ_PAR_FATHER_ID,FILTER_OPERATION) 
) 
;

CREATE TABLE SBI_OBJ_STATE (
	BIOBJ_ID INTEGER NOT NULL ,
	STATE_ID INTEGER NOT NULL ,
	START_DT DATE NOT NULL ,
	END_DT DATE,
	NOTE VARCHAR2 (300),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (BIOBJ_ID,STATE_ID,START_DT) 
)  
;

CREATE TABLE SBI_OBJECT_NOTES (
	OBJ_NOTE_ID INTEGER NOT NULL ,
	BIOBJ_ID INTEGER NOT NULL ,
	BIN_ID INTEGER,
	EXEC_REQ VARCHAR2 (500),
	OWNER VARCHAR2 (50),
	ISPUBLIC SMALLINT,
	CREATION_DATE TIMESTAMP(6) NOT NULL ,
	LAST_CHANGE_DATE TIMESTAMP(6) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (OBJ_NOTE_ID) 
) 
;

CREATE TABLE SBI_OBJECT_TEMPLATES (
	OBJ_TEMP_ID INTEGER NOT NULL ,
	BIOBJ_ID INTEGER NOT NULL ,
	BIN_ID INTEGER,
	NAME VARCHAR2 (50),
	PROG INTEGER,
	DIMENSION VARCHAR2 (20),
	CREATION_DATE DATE,
	CREATION_USER VARCHAR2 (45) NOT NULL ,
	ACTIVE SMALLINT,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (OBJ_TEMP_ID) 
) 
;

CREATE TABLE SBI_OBJECTS (
	BIOBJ_ID INTEGER NOT NULL ,
	ENGINE_ID INTEGER NOT NULL ,
	DESCR VARCHAR2 (400),
	LABEL VARCHAR2 (20) NOT NULL ,
	ENCRYPT SMALLINT,
	PATH VARCHAR2 (400),
	REL_NAME VARCHAR2 (400),
	STATE_ID INTEGER NOT NULL ,
	STATE_CD VARCHAR2 (20) NOT NULL ,
	BIOBJ_TYPE_CD VARCHAR2 (20) NOT NULL ,
	BIOBJ_TYPE_ID INTEGER NOT NULL ,
	SCHED_FL SMALLINT,
	EXEC_MODE_ID INTEGER,
	STATE_CONS_ID INTEGER,
	EXEC_MODE_CD VARCHAR2 (20),
	STATE_CONS_CD VARCHAR2 (20),
	NAME VARCHAR2 (200) NOT NULL ,
	VISIBLE SMALLINT NOT NULL ,
	UUID VARCHAR2 (40) NOT NULL ,
	DATA_SOURCE_ID INTEGER,
	DATA_SET_ID INTEGER,
	CREATION_DATE TIMESTAMP(6) NOT NULL ,
	CREATION_USER VARCHAR2 (45) NOT NULL ,
	REFRESH_SECONDS INTEGER DEFAULT 0,
	PROF_VISIBILITY VARCHAR2 (400),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_OBJECTS UNIQUE (LABEL, ORGANIZATION),
PRIMARY KEY (BIOBJ_ID) 
)  
;

CREATE TABLE SBI_OBJECTS_RATING (
	USER_ID VARCHAR2 (127) NOT NULL ,
	OBJ_ID INTEGER NOT NULL ,
	RATING INTEGER NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (USER_ID,OBJ_ID) 
) 
;

CREATE TABLE SBI_PARAMETERS (
	PAR_ID INTEGER NOT NULL ,
	DESCR VARCHAR2 (160),
	LENGTH SMALLINT NOT NULL ,
	LABEL VARCHAR2 (20) NOT NULL ,
	PAR_TYPE_CD VARCHAR2 (20) NOT NULL ,
	MASK VARCHAR2 (20),
	PAR_TYPE_ID INTEGER NOT NULL ,
	NAME VARCHAR2 (40) NOT NULL ,
	FUNCTIONAL_FLAG SMALLINT DEFAULT 1 NOT NULL ,
	TEMPORAL_FLAG SMALLINT DEFAULT 0 NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_PARAMETERS UNIQUE (LABEL, ORGANIZATION),
PRIMARY KEY (PAR_ID) 
)  
;

CREATE TABLE SBI_PARUSE (
	USE_ID INTEGER NOT NULL ,
	LOV_ID INTEGER,
	DEFAULT_LOV_ID INTEGER,
	DEFAULT_FORMULA VARCHAR2(4000) NULL,
	LABEL VARCHAR2 (20) NOT NULL ,
	DESCR VARCHAR2 (160),
	PAR_ID INTEGER NOT NULL ,
	NAME VARCHAR2 (40) NOT NULL ,
	MAN_IN INTEGER NOT NULL ,
	MAXIMIZER_ENABLED	SMALLINT DEFAULT 0,
	SELECTION_TYPE VARCHAR2 (20) DEFAULT 'LIST',
	MULTIVALUE_FLAG INTEGER DEFAULT 0,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (USE_ID) 
) 
;

CREATE TABLE SBI_PARUSE_CK (
	USE_ID INTEGER NOT NULL ,
	CHECK_ID INTEGER NOT NULL ,
	PROG INTEGER,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (USE_ID,CHECK_ID) 
) 
;

CREATE TABLE SBI_PARUSE_DET (
	USE_ID INTEGER NOT NULL ,
	EXT_ROLE_ID INTEGER NOT NULL ,
	PROG INTEGER,
	HIDDEN_FL SMALLINT,
	DEFAULT_VAL VARCHAR2 (40),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (USE_ID,EXT_ROLE_ID) 
) 
;

CREATE TABLE SBI_REMEMBER_ME (
	ID INTEGER NOT NULL ,
	USERNAME VARCHAR2 (40) NOT NULL ,
	BIOBJ_ID INTEGER NOT NULL ,
	SUBOBJ_ID INTEGER,
	PARAMETERS CLOB,
	NAME VARCHAR2 (50) NOT NULL ,
	DESCRIPTION CLOB,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ID) 
) 
;

CREATE TABLE SBI_ROLE_TYPE_USER_FUNC (
	ROLE_TYPE_ID INTEGER NOT NULL ,
	USER_FUNCT_ID INTEGER NOT NULL ,
PRIMARY KEY (ROLE_TYPE_ID,USER_FUNCT_ID) 
) 
;

CREATE TABLE SBI_SNAPSHOTS (
	SNAP_ID INTEGER NOT NULL ,
	BIOBJ_ID INTEGER NOT NULL ,
	BIN_ID INTEGER,
	NAME VARCHAR2 (100),
	DESCRIPTION VARCHAR2 (1000),
	CREATION_DATE TIMESTAMP(6) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (SNAP_ID) 
) 
;

CREATE TABLE SBI_SUBOBJECTS (
	SUBOBJ_ID INTEGER NOT NULL ,
	BIOBJ_ID INTEGER NOT NULL ,
	BIN_ID INTEGER,
	NAME VARCHAR2 (50) NOT NULL,
	DESCRIPTION VARCHAR2 (100),
	OWNER VARCHAR2 (50),
	ISPUBLIC SMALLINT,
	CREATION_DATE TIMESTAMP(6) NOT NULL ,
	LAST_CHANGE_DATE TIMESTAMP(6) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (SUBOBJ_ID) 
) 
;

CREATE TABLE SBI_SUBREPORTS (
	MASTER_RPT_ID INTEGER NOT NULL ,
	SUB_RPT_ID INTEGER NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (MASTER_RPT_ID,SUB_RPT_ID) 
) 
;

CREATE TABLE SBI_USER_FUNC (
	USER_FUNCT_ID INTEGER NOT NULL ,
	NAME VARCHAR2 (50),
	DESCRIPTION VARCHAR2 (100),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (USER_FUNCT_ID) 
) 
;

CREATE TABLE SBI_VIEWPOINTS (
	VP_ID INTEGER NOT NULL ,
	BIOBJ_ID INTEGER NOT NULL ,
	VP_NAME VARCHAR2 (40) NOT NULL ,
	VP_OWNER VARCHAR2 (40),
	VP_DESC VARCHAR2 (160),
	VP_SCOPE VARCHAR2 (20) NOT NULL ,
	VP_VALUE_PARAMS CLOB,
	VP_CREATION_DATE TIMESTAMP(6) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (VP_ID) 
) 
;


CREATE TABLE SBI_KPI_ROLE (
	ID_KPI_ROLE INTEGER NOT NULL,
	KPI_ID INTEGER NOT NULL,
	EXT_ROLE_ID INTEGER NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
 PRIMARY KEY (ID_KPI_ROLE)
 ) 
;

CREATE TABLE SBI_KPI (
	KPI_ID INTEGER NOT NULL ,
	ID_MEASURE_UNIT NUMBER(38,0),
	DS_ID NUMBER(38,0),
	ID_KPI_PARENT NUMBER(38,0),
	THRESHOLD_ID NUMBER(38,0),
	NAME VARCHAR2 (400)  NOT NULL ,
	CODE VARCHAR2 (40),
	METRIC VARCHAR2 (1000),
	DESCRIPTION VARCHAR2 (1000),
	WEIGHT NUMBER(38,0),
	IS_ADDITIVE CHAR (1),
	FLG_IS_FATHER CHAR (1),
	KPI_TYPE NUMBER(38,0),
	METRIC_SCALE_TYPE NUMBER(38,0),
	MEASURE_TYPE NUMBER(38,0),
	INTERPRETATION VARCHAR2 (1000),
	INPUT_ATTRIBUTES VARCHAR2 (1000),
	MODEL_REFERENCE VARCHAR2 (255),
	TARGET_AUDIENCE VARCHAR2 (1000),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_KPI UNIQUE (CODE, ORGANIZATION),
PRIMARY KEY (KPI_ID)  
) 
;

CREATE TABLE SBI_KPI_DOCUMENTS (
	ID_KPI_DOC INTEGER NOT NULL,
	BIOBJ_ID INTEGER NOT NULL,
	KPI_ID INTEGER NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
 PRIMARY KEY (ID_KPI_DOC)
) 
;


CREATE TABLE SBI_KPI_VALUE (
	ID_KPI_INSTANCE_VALUE NUMBER(38,0)  NOT NULL ,
	ID_KPI_INSTANCE NUMBER(38,0)  NOT NULL ,
	VALUE VARCHAR2 (40),
	BEGIN_DT TIMESTAMP(6),
	END_DT TIMESTAMP(6),
	RESOURCE_ID NUMBER(38,0),
	DESCRIPTION VARCHAR2 (100),
	XML_DATA CLOB,
	ORG_UNIT_ID INTEGER,
	HIERARCHY_ID INTEGER,
	COMPANY VARCHAR2(200),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ID_KPI_INSTANCE_VALUE) 
) 
;

CREATE TABLE SBI_MEASURE_UNIT (
	ID_MEASURE_UNIT NUMBER(38,0)  NOT NULL ,
	NAME VARCHAR2 (20),
	SCALE_TYPE_ID NUMBER(38,0)  NOT NULL ,
	SCALE_CD VARCHAR2 (40),
	SCALE_NM VARCHAR2 (400),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ID_MEASURE_UNIT) 
) 
;

CREATE TABLE SBI_THRESHOLD (
	THRESHOLD_ID NUMBER(38,0)  NOT NULL ,
	THRESHOLD_TYPE_ID NUMBER(38,0)  NOT NULL ,
	NAME VARCHAR2 (400),
	DESCRIPTION VARCHAR2 (1000),
	CODE VARCHAR2(45) NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XIF1SBI_THRESHOLD UNIQUE (CODE, ORGANIZATION),
PRIMARY KEY (THRESHOLD_ID) 
) 
;

CREATE TABLE SBI_THRESHOLD_VALUE (
	ID_THRESHOLD_VALUE NUMBER(38,0)  NOT NULL ,
	THRESHOLD_ID NUMBER(38,0)  NOT NULL ,
	SEVERITY_ID NUMBER(38,0),
	MIN_VALUE NUMBER,
	MAX_VALUE NUMBER,
	LABEL VARCHAR2 (20) NOT NULL,
	COLOUR VARCHAR2 (20),
	POSITION NUMBER(38,0),
	MIN_CLOSED SMALLINT,
	MAX_CLOSED SMALLINT,
	TH_VALUE NUMBER (38,0),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ID_THRESHOLD_VALUE) 
) 
;

CREATE TABLE SBI_KPI_MODEL (
	KPI_MODEL_ID NUMBER(38,0)  NOT NULL ,
	KPI_ID NUMBER(38,0),
	KPI_MODEL_TYPE_ID NUMBER(38,0)  NOT NULL ,
	KPI_PARENT_MODEL_ID NUMBER(38,0),
	KPI_MODEL_CD VARCHAR2 (40) NOT NULL,
	KPI_MODEL_NM VARCHAR2 (400),
	KPI_MODEL_DESC VARCHAR2 (1000),
	KPI_MODEL_LBL VARCHAR2(100) NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XIF1SBI_KPI_MODEL UNIQUE (KPI_MODEL_LBL, ORGANIZATION),
PRIMARY KEY (KPI_MODEL_ID) 
) 
;


CREATE TABLE SBI_KPI_PERIODICITY (
	ID_KPI_PERIODICITY NUMBER(38,0)  NOT NULL ,
	NAME VARCHAR2 (400) NOT NULL,
	MONTHS NUMBER(38,0),
	DAYS NUMBER(38,0),
	HOURS NUMBER(38,0),
	MINUTES NUMBER(38,0),
	CHRON_STRING VARCHAR2(20),
	START_DATE TIMESTAMP(6),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ID_KPI_PERIODICITY) 
) 
;


CREATE TABLE SBI_KPI_INSTANCE (
	ID_KPI_INSTANCE NUMBER(38,0)  NOT NULL ,
	KPI_ID NUMBER(38,0)  NOT NULL ,
	THRESHOLD_ID NUMBER(38,0),
	ID_MEASURE_UNIT NUMBER(38,0),
	WEIGHT NUMBER(38,0),
	BEGIN_DT TIMESTAMP(6),
	CHART_TYPE_ID NUMBER(38,0),
	TARGET NUMBER(38,4),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ID_KPI_INSTANCE) 
)  
;

CREATE TABLE SBI_KPI_INSTANCE_HISTORY (
	ID_KPI_INSTANCE_HISTORY NUMBER(38,0)  NOT NULL ,
	ID_MEASURE_UNIT NUMBER(38,0)   ,
	THRESHOLD_ID NUMBER(38,0)   ,
	ID_KPI_INSTANCE NUMBER(38,0)  NOT NULL ,
	WEIGHT NUMBER(38,0),
	BEGIN_DT TIMESTAMP(6),
	END_DT TIMESTAMP(6),
	CHART_TYPE_ID NUMBER(38,0),
	TARGET NUMBER(38,6),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ID_KPI_INSTANCE_HISTORY) 
)  
;

CREATE TABLE SBI_KPI_INST_PERIOD (
  KPI_INST_PERIOD_ID NUMBER(38,0) NOT NULL,
  KPI_INSTANCE_ID NUMBER(38,0) NOT NULL,
  PERIODICITY_ID NUMBER(38,0) NOT NULL,
  DEFAULT_VALUE SMALLINT DEFAULT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
  PRIMARY KEY (KPI_INST_PERIOD_ID)
) 
;

CREATE TABLE SBI_KPI_MODEL_INST (
	KPI_MODEL_INST NUMBER(38,0)  NOT NULL ,
	KPI_MODEL_INST_PARENT NUMBER(38,0),
	ID_KPI_INSTANCE NUMBER(38,0),
	NAME VARCHAR2 (400),
	LABEL VARCHAR2 (100) NOT NULL,
	DESCRIPTION VARCHAR2 (1000),
	START_DATE TIMESTAMP(6),
	END_DATE TIMESTAMP(6),
	KPI_MODEL_ID NUMBER(38,0),
	MODELUUID VARCHAR2(255),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK2SBI_KPI_MODEL_INST UNIQUE (LABEL, ORGANIZATION),
PRIMARY KEY (KPI_MODEL_INST) 
) 
;

CREATE TABLE SBI_RESOURCES (
	RESOURCE_ID NUMBER(38,0)  NOT NULL ,
	RESOURCE_TYPE_ID NUMBER(38,0)  NOT NULL ,
	TABLE_NAME VARCHAR2 (40),
	COLUMN_NAME VARCHAR2 (40),
	RESOURCE_NAME VARCHAR2 (40) NOT NULL,
    RESOURCE_CODE VARCHAR2 (45) NOT NULL,
	RESOURCE_DESCR VARCHAR2 (400),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XIF1SBI_RESOURCES UNIQUE (RESOURCE_CODE, ORGANIZATION),
PRIMARY KEY (RESOURCE_ID) 
) 
;

CREATE TABLE SBI_KPI_MODEL_RESOURCES (
	KPI_MODEL_RESOURCES_ID INTEGER NOT NULL,
	RESOURCE_ID INTEGER NOT NULL,
	KPI_MODEL_INST INTEGER NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
 PRIMARY KEY (KPI_MODEL_RESOURCES_ID)
) 
;

CREATE TABLE SBI_ALARM (
	ALARM_ID NUMBER(38,0)  NOT NULL ,
	ID_KPI_INSTANCE NUMBER(38,0),
	MODALITY_ID NUMBER(38,0)  NOT NULL ,
	DOCUMENT_ID NUMBER(38,0),
	LABEL VARCHAR2 (50) NOT NULL,
	NAME VARCHAR2 (50),
	DESCR VARCHAR2 (200),
	TEXT VARCHAR2 (1000),
	URL VARCHAR2 (20),
	SINGLE_EVENT CHAR (1),
	AUTO_DISABLED CHAR (1),
	ID_THRESHOLD_VALUE NUMBER(38,0),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XIF1SBI_ALARM UNIQUE (LABEL, ORGANIZATION),
PRIMARY KEY (ALARM_ID) 
) 
;

CREATE TABLE SBI_ALARM_EVENT (
	ALARM_EVENT_ID NUMBER(38,0)  NOT NULL ,
	ALARM_ID NUMBER(38,0)  NOT NULL ,
	EVENT_TS TIMESTAMP(6),
	ACTIVE CHAR (1),
	KPI_VALUE VARCHAR2 (50),
	THRESHOLD_VALUE VARCHAR2 (50),
	KPI_NAME VARCHAR2 (100),
	RESOURCES VARCHAR2 (200),
	KPI_DESCRIPTION VARCHAR2 (100),
	RESOURCE_ID NUMBER(38,0),
    KPI_INSTANCE_ID NUMBER(38,0),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (ALARM_EVENT_ID) 
)  
;

CREATE TABLE SBI_ALARM_DISTRIBUTION (
	ALARM_CONTACT_ID INTEGER NOT NULL,
	ALARM_ID INTEGER NOT NULL,
 PRIMARY KEY (ALARM_CONTACT_ID,ALARM_ID)
) 
;

CREATE TABLE SBI_ALARM_CONTACT (
	ALARM_CONTACT_ID INTEGER NOT NULL,
	NAME VARCHAR2(100) NOT NULL,
	EMAIL VARCHAR2(100),
	MOBILE VARCHAR2(50),
	RESOURCES VARCHAR2(200),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XIF1SBI_ALARM_CONTACT UNIQUE (NAME, ORGANIZATION),
 PRIMARY KEY (ALARM_CONTACT_ID)
)  
;

CREATE TABLE SBI_EXPORTERS (
	ENGINE_ID INTEGER NOT NULL,
	DOMAIN_ID INTEGER NOT NULL,
	DEFAULT_VALUE NUMBER(38,0) DEFAULT 0, 
PRIMARY KEY (DOMAIN_ID,ENGINE_ID)
) 
;

CREATE TABLE SBI_OBJ_METADATA (
	OBJ_META_ID 		INTEGER NOT NULL,
    LABEL	 	        VARCHAR2(20) NOT NULL,
    NAME 	            VARCHAR2(40) NOT NULL,
    DESCRIPTION	        VARCHAR2(100),  
    DATA_TYPE_ID		INTEGER NOT NULL,
    CREATION_DATE 	    TIMESTAMP(6) NOT NULL,   
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_OBJ_METADATA UNIQUE (LABEL, ORGANIZATION),
    PRIMARY KEY (OBJ_META_ID)
) 
;

CREATE TABLE SBI_OBJ_METACONTENTS (
  OBJ_METACONTENT_ID INTEGER  NOT NULL ,
  OBJMETA_ID 		 INTEGER  NOT NULL ,
  BIOBJ_ID 			 INTEGER  NOT NULL,
  SUBOBJ_ID 		 INTEGER,
  BIN_ID 			 INTEGER,
  CREATION_DATE 	 TIMESTAMP(6) NOT NULL,   
  LAST_CHANGE_DATE   TIMESTAMP(6) NOT NULL,   
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    PRIMARY KEY (OBJ_METACONTENT_ID)
) 
;

CREATE TABLE SBI_CONFIG (
	ID 				INTEGER NOT NULL,
	LABEL			VARCHAR2(100) NOT NULL,
	NAME			VARCHAR2(100) NULL,
	DESCRIPTION 	VARCHAR2(500) NULL,
	IS_ACTIVE 		SMALLINT DEFAULT 1,
	VALUE_CHECK 	VARCHAR2(1000) NULL,
	VALUE_TYPE_ID 	INTEGER NULL,  
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CATEGORY             VARCHAR2(50),
 PRIMARY KEY (ID)
 ) 
;
 CREATE TABLE SBI_USER (
	USER_ID VARCHAR2(100) NOT NULL,
	PASSWORD VARCHAR2(150),
	FULL_NAME VARCHAR2(255),
	ID INTEGER NOT NULL,
	DT_PWD_BEGIN TIMESTAMP(6),
	DT_PWD_END TIMESTAMP(6),
	FLG_PWD_BLOCKED SMALLINT,
	DT_LAST_ACCESS TIMESTAMP(6),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
 PRIMARY KEY (ID)
 ) 
;
CREATE TABLE SBI_ATTRIBUTE (
	ATTRIBUTE_NAME VARCHAR2(255) NOT NULL,
	DESCRIPTION VARCHAR2(500) NOT NULL,
	ATTRIBUTE_ID INTEGER NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_ATTRIBUTE UNIQUE ( ATTRIBUTE_NAME, ORGANIZATION ),
	PRIMARY KEY (ATTRIBUTE_ID)) 
;
CREATE TABLE SBI_USER_ATTRIBUTES (
	ID INTEGER NOT NULL,
	ATTRIBUTE_ID INTEGER NOT NULL,
	ATTRIBUTE_VALUE VARCHAR2(500),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
 PRIMARY KEY (ID,ATTRIBUTE_ID)) 
;

CREATE TABLE SBI_EXT_USER_ROLES (
	ID INTEGER NOT NULL,
	EXT_ROLE_ID INTEGER NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
 PRIMARY KEY (ID,EXT_ROLE_ID)) 
;

CREATE TABLE SBI_UDP (
	UDP_ID	        INTEGER  NOT NULL,
	TYPE_ID			INTEGER NOT NULL,
	FAMILY_ID		INTEGER NOT NULL,
	LABEL           VARCHAR2(20) NOT NULL,
	NAME            VARCHAR2(40) NOT NULL,
	DESCRIPTION     VARCHAR2(1000) NULL,
	IS_MULTIVALUE   SMALLINT DEFAULT 0, 
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XAK1SBI_UDP UNIQUE (LABEL, ORGANIZATION),
 PRIMARY KEY (UDP_ID)) 
;
 
 CREATE TABLE SBI_UDP_VALUE (
	UDP_VALUE_ID       INTEGER  NOT NULL,
	UDP_ID			   INTEGER NOT NULL,
	VALUE              VARCHAR2(1000) NULL,
	PROG               INTEGER NULL,
	LABEL              VARCHAR2(20) NULL,
	NAME               VARCHAR2(40) NULL,
	FAMILY			   VARCHAR2(40) NULL,
    BEGIN_TS           TIMESTAMP NOT NULL,
    END_TS             TIMESTAMP NULL,
    REFERENCE_ID	   INTEGER NULL,	
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
 PRIMARY KEY (UDP_VALUE_ID)) 
;
 
 
 CREATE TABLE SBI_KPI_ERROR (
  KPI_ERROR_ID        INTEGER   NOT NULL,
  KPI_MODEL_INST_ID   INTEGER   NOT NULL,
  USER_MSG            VARCHAR2(1000) NULL,
  FULL_MSG            CLOB   NULL,
  TS_DATE             TIMESTAMP NULL,
  LABEL_MOD_INST VARCHAR(100) ,
  PARAMETERS	   VARCHAR(1000),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
  PRIMARY KEY (KPI_ERROR_ID)) 
;


CREATE TABLE SBI_KPI_REL (
  KPI_REL_ID INTEGER NOT NULL,
  KPI_FATHER_ID INTEGER  NOT NULL,
  KPI_CHILD_ID INTEGER  NOT NULL,
  PARAMETER VARCHAR2(100),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
  PRIMARY KEY (KPI_REL_ID)
) 
;


CREATE TABLE SBI_ORG_UNIT (
  ID            INTEGER NOT NULL,
  LABEL            VARCHAR2(100) NOT NULL,
  NAME             VARCHAR2(200) NOT NULL,
  DESCRIPTION      VARCHAR2(1000),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
  CONSTRAINT XIF1SBI_ORG_UNIT UNIQUE (LABEL, NAME, ORGANIZATION),
  PRIMARY KEY(ID)
) 
;

CREATE TABLE SBI_ORG_UNIT_HIERARCHIES (
  ID            INTEGER NOT NULL,
  LABEL            VARCHAR2(100) NOT NULL,
  NAME             VARCHAR2(200) NOT NULL,
  DESCRIPTION      VARCHAR2(1000),
  TARGET     VARCHAR2(1000),
  COMPANY    VARCHAR2(100) NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
  CONSTRAINT XIF1SBI_ORG_UNIT_HIERARCHIES UNIQUE (LABEL, COMPANY, ORGANIZATION),
  PRIMARY KEY(ID)
) 
;

CREATE TABLE SBI_ORG_UNIT_NODES (
  NODE_ID            INTEGER NOT NULL,
  OU_ID           INTEGER NOT NULL,
  HIERARCHY_ID  INTEGER NOT NULL,
  PARENT_NODE_ID INTEGER NULL,
  PATH VARCHAR2(4000) NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
  PRIMARY KEY(NODE_ID)
) 
;

CREATE TABLE SBI_ORG_UNIT_GRANT (
  ID INTEGER NOT NULL,
  HIERARCHY_ID  INTEGER NOT NULL,
  KPI_MODEL_INST_NODE_ID INTEGER NOT NULL,
  START_DATE  DATE,
  END_DATE  DATE,
  LABEL            VARCHAR2(200) NOT NULL,
  NAME             VARCHAR2(400) NOT NULL,
  DESCRIPTION      VARCHAR2(1000),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    IS_AVAILABLE     NUMBER DEFAULT 1,
  CONSTRAINT XIF1SBI_ORG_UNIT_GRANT UNIQUE (LABEL, ORGANIZATION),
  PRIMARY KEY(ID)
) 
;

CREATE TABLE SBI_ORG_UNIT_GRANT_NODES (
  NODE_ID INTEGER NOT NULL,
  KPI_MODEL_INST_NODE_ID INTEGER NOT NULL,
  GRANT_ID INTEGER NOT NULL,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
  PRIMARY KEY(NODE_ID, KPI_MODEL_INST_NODE_ID, GRANT_ID)
) 
;

CREATE TABLE SBI_GOAL (
  GOAL_ID       INTEGER NOT NULL,
  GRANT_ID      INTEGER NOT NULL,
  START_DATE    DATE NOT NULL,
  END_DATE      DATE NOT NULL,
  NAME          VARCHAR2(20) NOT NULL,
  LABEL          VARCHAR2(20),
  DESCRIPTION		VARCHAR2(1000),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
    CONSTRAINT XIF1SBI_SBI_GOAL UNIQUE (NAME, ORGANIZATION),
  PRIMARY KEY (GOAL_ID)
) 
;


CREATE TABLE SBI_GOAL_HIERARCHY (
  GOAL_HIERARCHY_ID INTEGER NOT NULL,
  ORG_UNIT_ID       INTEGER NOT NULL,
  GOAL_ID           INTEGER NOT NULL,
  PARENT_ID         INTEGER,
  NAME              VARCHAR2(50) NOT NULL,
  LABEL             VARCHAR2(50),
  GOAL              VARCHAR2(1000),
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
  PRIMARY KEY (GOAL_HIERARCHY_ID)
) 
;


CREATE TABLE SBI_GOAL_KPI (
  GOAL_KPI_ID         INTEGER NOT NULL,
  KPI_INSTANCE_ID     INTEGER NOT NULL,
  GOAL_HIERARCHY_ID   INTEGER NOT NULL,
  WEIGHT1             NUMBER(20,2),
  WEIGHT2             NUMBER(20,2),
  THRESHOLD1          NUMBER(20,2),
  THRESHOLD2          NUMBER(20,2),
  THRESHOLD1SIGN      INTEGER,
  THRESHOLD2SIGN      INTEGER,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
  PRIMARY KEY (GOAL_KPI_ID)
)
;


CREATE TABLE SBI_OBJ_PARVIEW (
       OBJ_PAR_ID 			INTEGER NOT NULL,
   	   OBJ_PAR_FATHER_ID    INTEGER NOT NULL,
       OPERATION  			VARCHAR2(20) NOT NULL,
   	   COMPARE_VALUE  		VARCHAR2(200) NOT NULL,
   	   VIEW_LABEL   		VARCHAR2(50),
	     PROG INTEGER,
       USER_IN           	VARCHAR2(100) NOT NULL,
       USER_UP              VARCHAR2(100),
       USER_DE              VARCHAR2(100),
       TIME_IN              TIMESTAMP NOT NULL,
       TIME_UP              TIMESTAMP DEFAULT NULL,
       TIME_DE              TIMESTAMP DEFAULT NULL,
       SBI_VERSION_IN       VARCHAR2(10),
       SBI_VERSION_UP       VARCHAR2(10),
       SBI_VERSION_DE       VARCHAR2(10),
       META_VERSION         VARCHAR2(100),
       ORGANIZATION         VARCHAR2(20),    
  PRIMARY KEY ( OBJ_PAR_ID ,  OBJ_PAR_FATHER_ID ,  OPERATION, COMPARE_VALUE )
)
;

CREATE TABLE SBI_I18N_MESSAGES (
  LANGUAGE_CD INTEGER NOT NULL,
  LABEL VARCHAR(200) NOT NULL,
  MESSAGE CLOB,
  USER_IN              VARCHAR2(100) NOT NULL,
  USER_UP              VARCHAR2(100),
  USER_DE              VARCHAR2(100),
  TIME_IN              TIMESTAMP NOT NULL,
  TIME_UP              TIMESTAMP DEFAULT NULL,
  TIME_DE              TIMESTAMP DEFAULT NULL,
  SBI_VERSION_IN       VARCHAR2(10),
  SBI_VERSION_UP       VARCHAR2(10),
  SBI_VERSION_DE       VARCHAR2(10),
  META_VERSION         VARCHAR2(100),
  ORGANIZATION         VARCHAR2(20),
  PRIMARY KEY (LANGUAGE_CD, LABEL, ORGANIZATION)
)
;

CREATE TABLE SBI_KPI_COMMENTS (
	KPI_COMMENT_ID INTEGER NOT NULL ,
	KPI_INST_ID INTEGER NOT NULL ,
	BIN_ID INTEGER,
	EXEC_REQ VARCHAR2 (500),
	OWNER VARCHAR2 (50),
	ISPUBLIC SMALLINT,
	CREATION_DATE TIMESTAMP(6) NOT NULL ,
	LAST_CHANGE_DATE TIMESTAMP(6) NOT NULL ,
	USER_IN              VARCHAR2(100) NOT NULL,
    USER_UP              VARCHAR2(100),
    USER_DE              VARCHAR2(100),
    TIME_IN              TIMESTAMP NOT NULL,
    TIME_UP              TIMESTAMP DEFAULT NULL,    
    TIME_DE              TIMESTAMP DEFAULT NULL,
    SBI_VERSION_IN       VARCHAR2(10),
    SBI_VERSION_UP       VARCHAR2(10),
    SBI_VERSION_DE       VARCHAR2(10),
    META_VERSION         VARCHAR2(100),
    ORGANIZATION         VARCHAR2(20),
PRIMARY KEY (KPI_COMMENT_ID) 
)
;



CREATE TABLE SBI_PROGRESS_THREAD (
       PROGRESS_THREAD_ID   INTEGER NOT NULL,
       USER_ID              VARCHAR2(100) NOT NULL,
       PARTIAL              INTEGER,
       TOTAL        	      INTEGER,
       FUNCTION_CD         VARCHAR2(200),
       STATUS              VARCHAR2(4000),
       RANDOM_KEY			VARCHAR2(4000),
       TYPE 				VARCHAR2(200),	
       PRIMARY KEY (PROGRESS_THREAD_ID)
)
;


CREATE TABLE SBI_ORGANIZATIONS (
       ID     INTEGER NOT NULL,
       NAME   VARCHAR2(20),
       CONSTRAINT XAK1SBI_ORGANIZATIONS UNIQUE (NAME),
       PRIMARY KEY (ID)
)
;

CREATE TABLE SBI_META_MODELS (
       ID                   INTEGER NOT NULL,
       NAME                 VARCHAR2(100) NOT NULL,
       DESCR                VARCHAR2(500) NULL,
       USER_IN              VARCHAR2(100) NOT NULL,
       USER_UP              VARCHAR2(100),
       USER_DE              VARCHAR2(100),
       TIME_IN              TIMESTAMP NOT NULL,
       TIME_UP              TIMESTAMP DEFAULT NULL,    
       TIME_DE              TIMESTAMP DEFAULT NULL,
       SBI_VERSION_IN       VARCHAR2(10),
       SBI_VERSION_UP       VARCHAR2(10),
       SBI_VERSION_DE       VARCHAR2(10),
       META_VERSION         VARCHAR2(100),
       ORGANIZATION         VARCHAR2(20),
       CATEGORY_ID			INTEGER NULL,
       DATA_SOURCE_ID		INTEGER,
       CONSTRAINT XAK1SBI_META_MODELS UNIQUE (NAME, ORGANIZATION),
       PRIMARY KEY (ID)
)
;

CREATE TABLE SBI_META_MODELS_VERSIONS (
        ID                   INTEGER NOT NULL,
        MODEL_ID             INTEGER NOT NULL,
        CONTENT              BLOB NOT NULL,
        NAME                 VARCHAR2(100),  
        PROG                 INTEGER,
        CREATION_DATE        TIMESTAMP DEFAULT NULL,
        CREATION_USER        VARCHAR2(50) NOT NULL ,
        ACTIVE               SMALLINT,  
        USER_IN              VARCHAR2(100) NOT NULL,
        USER_UP              VARCHAR2(100),
        USER_DE              VARCHAR2(100),
        TIME_IN              TIMESTAMP NOT NULL,
        TIME_UP              TIMESTAMP DEFAULT NULL,    
        TIME_DE              TIMESTAMP DEFAULT NULL,
        SBI_VERSION_IN       VARCHAR2(10),
        SBI_VERSION_UP       VARCHAR2(10),
        SBI_VERSION_DE       VARCHAR2(10),
        META_VERSION         VARCHAR2(100),
        ORGANIZATION         VARCHAR2(20),
        PRIMARY KEY (ID)
)
;

ALTER TABLE SBI_META_MODELS_VERSIONS ADD CONSTRAINT FK_SBI_META_MODELS_VERSIONS_1 FOREIGN KEY ( MODEL_ID ) REFERENCES SBI_META_MODELS( ID ) ON DELETE CASCADE
;

CREATE TABLE SBI_ARTIFACTS (
       ID                   INTEGER NOT NULL,
       NAME                 VARCHAR2(100) NOT NULL,
       DESCR                VARCHAR2(500) NULL,
       TYPE                 VARCHAR2(50) NULL,
       USER_IN              VARCHAR2(100) NOT NULL,
       USER_UP              VARCHAR2(100),
       USER_DE              VARCHAR2(100),
       TIME_IN              TIMESTAMP NOT NULL,
       TIME_UP              TIMESTAMP DEFAULT NULL,    
       TIME_DE              TIMESTAMP DEFAULT NULL,
       SBI_VERSION_IN       VARCHAR2(10),
       SBI_VERSION_UP       VARCHAR2(10),
       SBI_VERSION_DE       VARCHAR2(10),
       META_VERSION         VARCHAR2(100),
       ORGANIZATION         VARCHAR2(20),
       CONSTRAINT XAK1SBI_ARTIFACTS UNIQUE (NAME, TYPE, ORGANIZATION),
       PRIMARY KEY (ID)
)
;

CREATE TABLE SBI_ARTIFACTS_VERSIONS (
        ID                   INTEGER NOT NULL,
        ARTIFACT_ID          INTEGER NOT NULL,
        CONTENT              BLOB NOT NULL,
        NAME                 VARCHAR2(100),  
        PROG                 INTEGER,
        CREATION_DATE        TIMESTAMP DEFAULT NULL,
        CREATION_USER        VARCHAR2(50) NOT NULL ,
        ACTIVE               SMALLINT, 
        USER_IN              VARCHAR2(100) NOT NULL,
        USER_UP              VARCHAR2(100),
        USER_DE              VARCHAR2(100),
        TIME_IN              TIMESTAMP NOT NULL,
        TIME_UP              TIMESTAMP DEFAULT NULL,    
        TIME_DE              TIMESTAMP DEFAULT NULL,
        SBI_VERSION_IN       VARCHAR2(10),
        SBI_VERSION_UP       VARCHAR2(10),
        SBI_VERSION_DE       VARCHAR2(10),
        META_VERSION         VARCHAR2(100),
        ORGANIZATION         VARCHAR2(20),
        PRIMARY KEY (ID)
)
;

CREATE TABLE  SBI_EXT_ROLES_CATEGORY (
  EXT_ROLE_ID INTEGER NOT NULL,
  CATEGORY_ID INTEGER NOT NULL,
  PRIMARY KEY (EXT_ROLE_ID,CATEGORY_ID),
  CONSTRAINT FK_SB_EXT_ROLES_META_MODEL_C_1 FOREIGN KEY (EXT_ROLE_ID) REFERENCES SBI_EXT_ROLES (EXT_ROLE_ID),
  CONSTRAINT FK_SB_EXT_ROLES_META_MODEL_C_2 FOREIGN KEY (CATEGORY_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
) ;


-- CREATE INDEXES SECTION

CREATE INDEX FK_SBI_AUDIT_1 ON SBI_AUDIT (DOC_REF)  
;
CREATE INDEX FK_SBI_AUDIT_2 ON SBI_AUDIT (ENGINE_REF)   
;
CREATE INDEX FK_SBI_AUDIT_3 ON SBI_AUDIT (SUBOBJ_REF)  
;
CREATE INDEX XIF3SBI_CHECKS ON SBI_CHECKS (VALUE_TYPE_ID)  
;
CREATE INDEX FK_SBI_DATA_SOURCE_1 ON SBI_DATA_SOURCE (DIALECT_ID)  
;
CREATE INDEX FK_SBI_DISTRIBUTION_LISTS_OBJE ON SBI_DIST_LIST_OBJECTS (DOC_ID)  
;
CREATE INDEX FK_SBI_DISTRIBUTION_LISTS_DLID ON SBI_DIST_LIST_OBJECTS (DL_ID)  
;
CREATE INDEX FK_SBI_DOSSIER_BINARY_CONTENTS ON SBI_DOSSIER_BIN_TEMP (PART_ID)  
;
CREATE INDEX FK_SBI_DOSSIER_TEMP_1 ON SBI_DOSSIER_TEMP (BIOBJ_ID)  
;
CREATE INDEX FK_SBI_DOSSIER_PRES_1 ON SBI_DOSSIER_PRES (BIN_ID)  
;
CREATE INDEX FK_SBI_DOSSIER_PRES_2 ON SBI_DOSSIER_PRES (BIOBJ_ID)  
;
CREATE INDEX FK_SBI_ENGINES_1 ON SBI_ENGINES (BIOBJ_TYPE)  
;
CREATE INDEX FK_SBI_ENGINES_2 ON SBI_ENGINES (ENGINE_TYPE)  
;
CREATE INDEX FK_SBI_ENGINES_3 ON SBI_ENGINES (DEFAULT_DS_ID)  
;
CREATE INDEX FK_SBI_EVENTS_ROLES_1 ON SBI_EVENTS_ROLES (ROLE_ID)  
;
CREATE INDEX XIF1SBI_EXT_ROLES ON SBI_EXT_ROLES (ROLE_TYPE_ID)  
;
CREATE INDEX XIF1SBI_FUNC_ROLE ON SBI_FUNC_ROLE (ROLE_ID)  
;
CREATE INDEX XIF2SBI_FUNC_ROLE ON SBI_FUNC_ROLE (FUNCT_ID)  
;
CREATE INDEX XIF4SBI_FUNC_ROLE ON SBI_FUNC_ROLE (STATE_ID)  
;
CREATE INDEX XIF1SBI_FUNCTIONS ON SBI_FUNCTIONS (FUNCT_TYPE_ID)  
;
CREATE INDEX XIF2SBI_FUNCTIONS ON SBI_FUNCTIONS (PARENT_FUNCT_ID)  
;
CREATE INDEX FK_GEO_MAP_FEATURES2 ON SBI_GEO_MAP_FEATURES (FEATURE_ID)  
;
CREATE INDEX XIF3SBI_LOV ON SBI_LOV (INPUT_TYPE_ID)  
;
CREATE INDEX XIF1SBI_OBJ_FUNC ON SBI_OBJ_FUNC (BIOBJ_ID)  
;
CREATE INDEX XIF2SBI_OBJ_FUNC ON SBI_OBJ_FUNC (FUNCT_ID)  
;
CREATE INDEX XIF1SBI_OBJ_PAR ON SBI_OBJ_PAR (PAR_ID)  
;
CREATE INDEX XIF2SBI_OBJ_PAR ON SBI_OBJ_PAR (BIOBJ_ID)  
;
CREATE INDEX FK_SBI_OBJ_PARUSE_2 ON SBI_OBJ_PARUSE (USE_ID)  
;
CREATE INDEX FK_SBI_OBJ_PARUSE_3 ON SBI_OBJ_PARUSE (OBJ_PAR_FATHER_ID)  
;
CREATE INDEX XIF3SBI_OBJ_STATE ON SBI_OBJ_STATE (BIOBJ_ID)  
;
CREATE INDEX XIF4SBI_OBJ_STATE ON SBI_OBJ_STATE (STATE_ID)  
;
CREATE INDEX FK_SBI_OBJECT_NOTES_1 ON SBI_OBJECT_NOTES (BIN_ID)  
;
CREATE INDEX FK_SBI_OBJECT_NOTES_2 ON SBI_OBJECT_NOTES (BIOBJ_ID)  
;
CREATE INDEX FK_SBI_OBJECT_TEMPLATES_1 ON SBI_OBJECT_TEMPLATES (BIN_ID)  
;
CREATE INDEX FK_SBI_OBJECT_TEMPLATES_2 ON SBI_OBJECT_TEMPLATES (BIOBJ_ID)  
;
CREATE INDEX XIF2SBI_OBJECTS ON SBI_OBJECTS (STATE_ID)  
;
CREATE INDEX XIF4SBI_OBJECTS ON SBI_OBJECTS (BIOBJ_TYPE_ID)  
;
CREATE INDEX XIF5SBI_OBJECTS ON SBI_OBJECTS (EXEC_MODE_ID)  
;
CREATE INDEX XIF6SBI_OBJECTS ON SBI_OBJECTS (STATE_CONS_ID)  
;
CREATE INDEX FK_SBI_OBJECTS_5 ON SBI_OBJECTS (ENGINE_ID)  
;
CREATE INDEX FK_SBI_OBJECTS_6 ON SBI_OBJECTS (DATA_SOURCE_ID)  
;
CREATE INDEX FK_SBI_OBJECTS_RATING_1 ON SBI_OBJECTS_RATING (OBJ_ID)  
;
CREATE INDEX XIF1SBI_PARAMETERS ON SBI_PARAMETERS (PAR_TYPE_ID)  
;
CREATE INDEX XIF1SBI_PARUSE ON SBI_PARUSE (PAR_ID)  
;
CREATE INDEX XIF2SBI_PARUSE ON SBI_PARUSE (LOV_ID)  
;
CREATE INDEX XIF3SBI_PARUSE ON SBI_PARUSE (DEFAULT_LOV_ID)  
;
CREATE INDEX XIF1SBI_PARUSE_CK ON SBI_PARUSE_CK (USE_ID)  
;
CREATE INDEX XIF2SBI_PARUSE_CK ON SBI_PARUSE_CK (CHECK_ID)  
;
CREATE INDEX XIF2SBI_PARUSE_DET ON SBI_PARUSE_DET (EXT_ROLE_ID)  
;
CREATE INDEX XIF3SBI_PARUSE_DET ON SBI_PARUSE_DET (USE_ID)  
;
CREATE INDEX FK_SBI_REMEMBER_ME_1 ON SBI_REMEMBER_ME (BIOBJ_ID)  
;
CREATE INDEX FK_SBI_REMEMBER_ME_2 ON SBI_REMEMBER_ME (SUBOBJ_ID)  
;
CREATE INDEX FK_SBI_ROLE_TYPE_USER_FUNCTION ON SBI_ROLE_TYPE_USER_FUNC (USER_FUNCT_ID)   
;
CREATE INDEX FK_SBI_SNAPSHOTS_1 ON SBI_SNAPSHOTS (BIN_ID)  
;
CREATE INDEX FK_SBI_SNAPSHOTS_2 ON SBI_SNAPSHOTS (BIOBJ_ID)  
;
CREATE INDEX FK_SBI_SUBOBJECTS_1 ON SBI_SUBOBJECTS (BIN_ID)  
;
CREATE INDEX FK_SBI_SUBOBJECTS_2 ON SBI_SUBOBJECTS (BIOBJ_ID)  
;
CREATE INDEX FK_SBI_SUBREPORTS_2 ON SBI_SUBREPORTS (SUB_RPT_ID)  
;
CREATE INDEX FK_SBI_VIEWPOINTS_1 ON SBI_VIEWPOINTS (BIOBJ_ID)  
;
CREATE UNIQUE INDEX XAK1SBI_OBJ_METACONTENTS ON SBI_OBJ_METACONTENTS(OBJMETA_ID,BIOBJ_ID,SUBOBJ_ID)  
;
CREATE UNIQUE INDEX XAK1SBI_USER ON SBI_USER(USER_ID)  
;
CREATE INDEX XIF3_SBI_SBI_UDP ON SBI_UDP(TYPE_ID  ASC)  
;
CREATE INDEX XIF2SBI_SBI_UDP ON SBI_UDP(FAMILY_ID ASC)  
;
CREATE INDEX XIF2SBI_SBI_UDP_VALUE ON SBI_UDP_VALUE(UDP_ID ASC)  
;

CREATE INDEX XAK1SBI_PARVIEW ON SBI_OBJ_PARVIEW ( OBJ_PAR_ID ASC, OBJ_PAR_FATHER_ID ASC)  
;
CREATE UNIQUE INDEX MODEL_CD_PAR_ID_UNIQUE ON SBI_KPI_MODEL (KPI_MODEL_CD,KPI_PARENT_MODEL_ID)  
;
CREATE UNIQUE INDEX LABEL_THID_UNIQUE ON SBI_THRESHOLD_VALUE (LABEL,THRESHOLD_ID)  
;
CREATE UNIQUE INDEX XAK1SBI_CONFIG ON SBI_CONFIG(LABEL)  
;

-- CREATE FOREIGN KEYS SECTION

ALTER TABLE SBI_DOSSIER_PRES ADD CONSTRAINT SBI_DOSSIER_PRES_1  FOREIGN KEY (BIN_ID) REFERENCES SBI_BINARY_CONTENTS (BIN_ID) 
;
ALTER TABLE SBI_DOSSIER_PRES ADD CONSTRAINT SBI_DOSSIER_PRES_2 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_OBJECT_NOTES ADD CONSTRAINT SBI_OBJECT_NOTES_1 FOREIGN KEY (BIN_ID) REFERENCES SBI_BINARY_CONTENTS (BIN_ID)
; 
ALTER TABLE SBI_OBJECT_NOTES ADD CONSTRAINT SBI_OBJECT_NOTES_2 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_OBJECT_TEMPLATES ADD CONSTRAINT SBI_OBJECT_TEMPLATES_1 FOREIGN KEY (BIN_ID) REFERENCES SBI_BINARY_CONTENTS (BIN_ID)
; 
ALTER TABLE SBI_OBJECT_TEMPLATES ADD CONSTRAINT SBI_OBJECT_TEMPLATES_2 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_SNAPSHOTS ADD CONSTRAINT SBI_SNAPSHOTS_1 FOREIGN KEY (BIN_ID) REFERENCES SBI_BINARY_CONTENTS (BIN_ID)
; 
ALTER TABLE SBI_SNAPSHOTS ADD CONSTRAINT SBI_SNAPSHOTS_2 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_SUBOBJECTS ADD CONSTRAINT SBI_SUBOBJECTS_1 FOREIGN KEY (BIN_ID) REFERENCES SBI_BINARY_CONTENTS (BIN_ID)
; 
ALTER TABLE SBI_SUBOBJECTS ADD CONSTRAINT SBI_SUBOBJECTS_2 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_PARUSE_CK ADD CONSTRAINT SBI_PARUSE_CK_1 FOREIGN KEY (CHECK_ID) REFERENCES SBI_CHECKS (CHECK_ID) 
;
ALTER TABLE SBI_PARUSE_CK ADD CONSTRAINT SBI_PARUSE_CK_2 FOREIGN KEY (USE_ID) REFERENCES SBI_PARUSE (USE_ID) 
;

ALTER TABLE SBI_ENGINES ADD CONSTRAINT SBI_ENGINES_1 FOREIGN KEY (DEFAULT_DS_ID) REFERENCES SBI_DATA_SOURCE (DS_ID)
; 
ALTER TABLE SBI_ENGINES ADD CONSTRAINT SBI_ENGINES_2 FOREIGN KEY (BIOBJ_TYPE) REFERENCES SBI_DOMAINS (VALUE_ID) 
;
ALTER TABLE SBI_ENGINES ADD CONSTRAINT SBI_ENGINES_3 FOREIGN KEY (ENGINE_TYPE) REFERENCES SBI_DOMAINS (VALUE_ID) 
;

ALTER TABLE SBI_DIST_LIST_USER ADD CONSTRAINT SBI_DIST_LIST_USER_1 FOREIGN KEY (LIST_ID) REFERENCES SBI_DIST_LIST (DL_ID)  ON DELETE CASCADE
;

ALTER TABLE SBI_DIST_LIST_OBJECTS ADD CONSTRAINT SBI_DIST_LIST_OBJECTS_1 FOREIGN KEY (DL_ID) REFERENCES SBI_DIST_LIST (DL_ID)  ON DELETE CASCADE
;
ALTER TABLE SBI_DIST_LIST_OBJECTS ADD CONSTRAINT SBI_DIST_LIST_OBJECTS_2 FOREIGN KEY (DOC_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID)  ON DELETE CASCADE
;

ALTER TABLE SBI_CHECKS ADD CONSTRAINT SBI_CHECKS_1 FOREIGN KEY (VALUE_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID) 
;

ALTER TABLE SBI_DATA_SOURCE ADD CONSTRAINT SBI_DATA_SOURCE_1 FOREIGN KEY (DIALECT_ID) REFERENCES SBI_DOMAINS (VALUE_ID) 
;

ALTER TABLE SBI_EXT_ROLES ADD CONSTRAINT SBI_EXT_ROLES_1 FOREIGN KEY (ROLE_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID) 
;

ALTER TABLE SBI_FUNC_ROLE ADD CONSTRAINT SBI_FUNC_ROLE_1 FOREIGN KEY (STATE_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_FUNC_ROLE ADD CONSTRAINT SBI_FUNC_ROLE_2 FOREIGN KEY (FUNCT_ID) REFERENCES SBI_FUNCTIONS (FUNCT_ID) 
;
ALTER TABLE SBI_FUNC_ROLE ADD CONSTRAINT SBI_FUNC_ROLE_3 FOREIGN KEY (ROLE_ID) REFERENCES SBI_EXT_ROLES (EXT_ROLE_ID) 
;

ALTER TABLE SBI_FUNCTIONS ADD CONSTRAINT SBI_FUNCTIONS_1 FOREIGN KEY (FUNCT_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
; 
ALTER TABLE SBI_FUNCTIONS ADD CONSTRAINT SBI_FUNCTIONS_2 FOREIGN KEY (PARENT_FUNCT_ID) REFERENCES SBI_FUNCTIONS (FUNCT_ID) 
;

ALTER TABLE SBI_LOV ADD CONSTRAINT SBI_LOV_1 FOREIGN KEY (INPUT_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID) 
;

ALTER TABLE SBI_OBJ_STATE ADD CONSTRAINT SBI_OBJ_STATE_1 FOREIGN KEY (STATE_ID) REFERENCES SBI_DOMAINS (VALUE_ID) 
;
ALTER TABLE SBI_OBJ_STATE ADD CONSTRAINT SBI_OBJ_STATE_2 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_OBJECTS ADD CONSTRAINT SBI_OBJECTS_1 FOREIGN KEY (DATA_SOURCE_ID) REFERENCES SBI_DATA_SOURCE (DS_ID) 
;
ALTER TABLE SBI_OBJECTS ADD CONSTRAINT SBI_OBJECTS_2 FOREIGN KEY (STATE_CONS_ID) REFERENCES SBI_DOMAINS (VALUE_ID) 
;
ALTER TABLE SBI_OBJECTS ADD CONSTRAINT SBI_OBJECTS_3 FOREIGN KEY (STATE_ID) REFERENCES SBI_DOMAINS (VALUE_ID) 
;
ALTER TABLE SBI_OBJECTS ADD CONSTRAINT SBI_OBJECTS_4 FOREIGN KEY (BIOBJ_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID) 
;
ALTER TABLE SBI_OBJECTS ADD CONSTRAINT SBI_OBJECTS_5 FOREIGN KEY (EXEC_MODE_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
; 
ALTER TABLE SBI_OBJECTS ADD CONSTRAINT SBI_OBJECTS_6 FOREIGN KEY (ENGINE_ID) REFERENCES SBI_ENGINES (ENGINE_ID) 
;

ALTER TABLE SBI_PARAMETERS ADD CONSTRAINT SBI_PARAMETERS_1 FOREIGN KEY (PAR_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID) 
;

ALTER TABLE SBI_ROLE_TYPE_USER_FUNC ADD CONSTRAINT SBI_ROLE_TYPE_USER_FUNC_1 FOREIGN KEY (ROLE_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
; 
ALTER TABLE SBI_ROLE_TYPE_USER_FUNC ADD CONSTRAINT SBI_ROLE_TYPE_USER_FUNC_2 FOREIGN KEY (USER_FUNCT_ID) REFERENCES SBI_USER_FUNC (USER_FUNCT_ID) 
;

ALTER TABLE SBI_DOSSIER_BIN_TEMP ADD CONSTRAINT SBI_DOSSIER_BIN_TEMP_1 FOREIGN KEY (PART_ID) REFERENCES SBI_DOSSIER_TEMP (PART_ID)  ON DELETE CASCADE
;

ALTER TABLE SBI_AUDIT ADD CONSTRAINT SBI_AUDIT_1 FOREIGN KEY (ENGINE_REF) REFERENCES SBI_ENGINES (ENGINE_ID)  ON DELETE SET NULL
;
ALTER TABLE SBI_AUDIT ADD CONSTRAINT SBI_AUDIT_2 FOREIGN KEY (DOC_REF) REFERENCES SBI_OBJECTS (BIOBJ_ID)  ON DELETE SET NULL
;
ALTER TABLE SBI_AUDIT ADD CONSTRAINT SBI_AUDIT_3 FOREIGN KEY (SUBOBJ_REF) REFERENCES SBI_SUBOBJECTS (SUBOBJ_ID)  ON DELETE SET NULL
;

ALTER TABLE SBI_EVENTS_ROLES ADD CONSTRAINT SBI_EVENTS_ROLES_1 FOREIGN KEY (EVENT_ID) REFERENCES SBI_EVENTS_LOG (ID)
; 
ALTER TABLE SBI_EVENTS_ROLES ADD CONSTRAINT SBI_EVENTS_ROLES_2 FOREIGN KEY (ROLE_ID) REFERENCES SBI_EXT_ROLES (EXT_ROLE_ID) 
;


ALTER TABLE SBI_PARUSE_DET ADD CONSTRAINT SBI_PARUSE_DET_1 FOREIGN KEY (EXT_ROLE_ID) REFERENCES SBI_EXT_ROLES (EXT_ROLE_ID)
; 
ALTER TABLE SBI_PARUSE_DET ADD CONSTRAINT SBI_PARUSE_DET_2 FOREIGN KEY (USE_ID) REFERENCES SBI_PARUSE (USE_ID) 
;


ALTER TABLE SBI_OBJ_FUNC ADD CONSTRAINT SBI_OBJ_FUNC_1 FOREIGN KEY (FUNCT_ID) REFERENCES SBI_FUNCTIONS (FUNCT_ID) 
;
ALTER TABLE SBI_OBJ_FUNC ADD CONSTRAINT SBI_OBJ_FUNC_2 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_GEO_MAPS ADD CONSTRAINT SBI_GEO_MAPS_1 FOREIGN KEY (BIN_ID) REFERENCES SBI_BINARY_CONTENTS (BIN_ID) 
;

ALTER TABLE SBI_GEO_MAP_FEATURES ADD CONSTRAINT SBI_GEO_MAP_FEATURES_1 FOREIGN KEY (FEATURE_ID) REFERENCES SBI_GEO_FEATURES (FEATURE_ID)
; 
ALTER TABLE SBI_GEO_MAP_FEATURES ADD CONSTRAINT SBI_GEO_MAP_FEATURES_2 FOREIGN KEY (MAP_ID) REFERENCES SBI_GEO_MAPS (MAP_ID) 
;

ALTER TABLE SBI_PARUSE ADD CONSTRAINT SBI_PARUSE_1 FOREIGN KEY (LOV_ID) REFERENCES SBI_LOV (LOV_ID) 
;
ALTER TABLE SBI_PARUSE ADD CONSTRAINT SBI_PARUSE_2 FOREIGN KEY (PAR_ID) REFERENCES SBI_PARAMETERS (PAR_ID) 
;
ALTER TABLE SBI_PARUSE ADD CONSTRAINT SBI_PARUSE_3 FOREIGN KEY (DEFAULT_LOV_ID) REFERENCES SBI_LOV (LOV_ID) 
;

ALTER TABLE SBI_OBJ_PARUSE ADD CONSTRAINT SBI_OBJ_PARUSE_1 FOREIGN KEY (OBJ_PAR_ID) REFERENCES SBI_OBJ_PAR (OBJ_PAR_ID) 
;
ALTER TABLE SBI_OBJ_PARUSE ADD CONSTRAINT SBI_OBJ_PARUSE_2 FOREIGN KEY (OBJ_PAR_FATHER_ID) REFERENCES SBI_OBJ_PAR (OBJ_PAR_ID)
; 
ALTER TABLE SBI_OBJ_PARUSE ADD CONSTRAINT SBI_OBJ_PARUSE_3 FOREIGN KEY (USE_ID) REFERENCES SBI_PARUSE (USE_ID) 
;

ALTER TABLE SBI_DOSSIER_TEMP ADD CONSTRAINT SBI_DOSSIER_TEMP_1 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_OBJ_PAR ADD CONSTRAINT SBI_OBJ_PAR_1 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;
ALTER TABLE SBI_OBJ_PAR ADD CONSTRAINT SBI_OBJ_PAR_2 FOREIGN KEY (PAR_ID) REFERENCES SBI_PARAMETERS (PAR_ID) 
;

ALTER TABLE SBI_OBJECTS_RATING ADD CONSTRAINT SBI_OBJECTS_RATING_1 FOREIGN KEY (OBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID)  ON DELETE CASCADE
;

ALTER TABLE SBI_REMEMBER_ME ADD CONSTRAINT SBI_REMEMBER_ME_1 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID)  ON DELETE CASCADE
;
ALTER TABLE SBI_REMEMBER_ME ADD CONSTRAINT SBI_REMEMBER_ME_2 FOREIGN KEY (SUBOBJ_ID) REFERENCES SBI_SUBOBJECTS (SUBOBJ_ID)  ON DELETE CASCADE
;

ALTER TABLE SBI_SUBREPORTS ADD CONSTRAINT SBI_SUBREPORTS_1 FOREIGN KEY (MASTER_RPT_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID)
; 
ALTER TABLE SBI_SUBREPORTS ADD CONSTRAINT SBI_SUBREPORTS_2 FOREIGN KEY (SUB_RPT_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_VIEWPOINTS ADD CONSTRAINT SBI_VIEWPOINTS_1 FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID) 
;

ALTER TABLE SBI_MENU_ROLE ADD CONSTRAINT SBI_MENU_ROLE_1 FOREIGN KEY (MENU_ID) REFERENCES SBI_MENU (MENU_ID) ON DELETE CASCADE
;
ALTER TABLE SBI_MENU_ROLE ADD CONSTRAINT SBI_MENU_ROLE_2 FOREIGN KEY (EXT_ROLE_ID) REFERENCES SBI_EXT_ROLES (EXT_ROLE_ID) ON DELETE CASCADE
;
ALTER TABLE SBI_UDP ADD CONSTRAINT FK_SBI_SBI_UDP_1 FOREIGN KEY ( TYPE_ID ) REFERENCES SBI_DOMAINS ( VALUE_ID )
;
ALTER TABLE SBI_UDP ADD CONSTRAINT FK_SBI_SBI_UDP_2 FOREIGN KEY ( FAMILY_ID ) REFERENCES SBI_DOMAINS ( VALUE_ID )
;
ALTER TABLE SBI_UDP_VALUE ADD CONSTRAINT FK_SBI_UDP_VALUE_1 FOREIGN KEY ( UDP_ID ) REFERENCES SBI_UDP ( UDP_ID )
;
ALTER TABLE SBI_KPI_MODEL ADD CONSTRAINT SBI_KPI_MODEL_1 FOREIGN KEY (KPI_MODEL_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_KPI_MODEL ADD CONSTRAINT SBI_KPI_MODEL_2 FOREIGN KEY (KPI_ID) REFERENCES SBI_KPI (KPI_ID)
;
ALTER TABLE SBI_KPI_MODEL ADD CONSTRAINT SBI_KPI_MODEL_3 FOREIGN KEY (KPI_PARENT_MODEL_ID) REFERENCES SBI_KPI_MODEL (KPI_MODEL_ID)
;
ALTER TABLE SBI_MEASURE_UNIT ADD CONSTRAINT SBI_MEASURE_UNIT_1 FOREIGN KEY (SCALE_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_KPI ADD CONSTRAINT SBI_KPI_2 FOREIGN KEY (ID_KPI_PARENT) REFERENCES SBI_KPI (KPI_ID)
;
ALTER TABLE SBI_KPI ADD CONSTRAINT SBI_KPI_3 FOREIGN KEY (ID_MEASURE_UNIT) REFERENCES SBI_MEASURE_UNIT (ID_MEASURE_UNIT)
;
ALTER TABLE SBI_KPI ADD CONSTRAINT SBI_KPI_4 FOREIGN KEY (THRESHOLD_ID) REFERENCES SBI_THRESHOLD (THRESHOLD_ID) 
;
ALTER TABLE SBI_KPI_DOCUMENTS  ADD CONSTRAINT FK_SBI_KPI_DOCUMENTS_1 FOREIGN KEY ( BIOBJ_ID ) REFERENCES  SBI_OBJECTS  ( BIOBJ_ID ) ON DELETE CASCADE
;
ALTER TABLE SBI_KPI_DOCUMENTS ADD CONSTRAINT SBI_KPI_DOCUMENTS_2 FOREIGN KEY (KPI_ID) REFERENCES SBI_KPI (KPI_ID)
;
ALTER TABLE SBI_KPI_ROLE ADD CONSTRAINT SBI_KPI_ROLE_1 FOREIGN KEY (EXT_ROLE_ID) REFERENCES SBI_EXT_ROLES (EXT_ROLE_ID) 
;
ALTER TABLE SBI_KPI_ROLE ADD CONSTRAINT SBI_KPI_ROLE_2 FOREIGN KEY (KPI_ID) REFERENCES SBI_KPI (KPI_ID)
;
ALTER TABLE SBI_THRESHOLD ADD CONSTRAINT SBI_THRESHOLD_1 FOREIGN KEY (THRESHOLD_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_THRESHOLD_VALUE ADD CONSTRAINT SBI_THRESHOLD_VALUE_1 FOREIGN KEY (SEVERITY_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_THRESHOLD_VALUE ADD CONSTRAINT SBI_THRESHOLD_VALUE_2 FOREIGN KEY (THRESHOLD_ID) REFERENCES SBI_THRESHOLD (THRESHOLD_ID) ON DELETE CASCADE
;
ALTER TABLE SBI_KPI_MODEL_INST ADD CONSTRAINT SBI_KPI_MODEL_INST_1 FOREIGN KEY (ID_KPI_INSTANCE) REFERENCES SBI_KPI_INSTANCE (ID_KPI_INSTANCE)
;
ALTER TABLE SBI_KPI_MODEL_INST ADD CONSTRAINT SBI_KPI_MODEL_INST_2 FOREIGN KEY (KPI_MODEL_INST_PARENT) REFERENCES SBI_KPI_MODEL_INST (KPI_MODEL_INST)
;
ALTER TABLE SBI_KPI_MODEL_INST ADD CONSTRAINT SBI_KPI_MODEL_INST_3 FOREIGN KEY (KPI_MODEL_ID) REFERENCES SBI_KPI_MODEL (KPI_MODEL_ID)
;
ALTER TABLE SBI_KPI_INSTANCE ADD CONSTRAINT SBI_KPI_INSTANCE_1 FOREIGN KEY (KPI_ID) REFERENCES SBI_KPI (KPI_ID)
;
ALTER TABLE SBI_KPI_INSTANCE ADD CONSTRAINT SBI_KPI_INSTANCE_2 FOREIGN KEY (ID_MEASURE_UNIT) REFERENCES SBI_MEASURE_UNIT (ID_MEASURE_UNIT)
;
ALTER TABLE SBI_KPI_INSTANCE ADD CONSTRAINT SBI_KPI_INSTANCE_3 FOREIGN KEY (THRESHOLD_ID) REFERENCES SBI_THRESHOLD (THRESHOLD_ID)
;
ALTER TABLE SBI_KPI_INSTANCE ADD CONSTRAINT SBI_KPI_INSTANCE_4 FOREIGN KEY (CHART_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_KPI_INSTANCE_HISTORY ADD CONSTRAINT SBI_KPI_INSTANCE_HISTORY_1 FOREIGN KEY (ID_MEASURE_UNIT) REFERENCES SBI_MEASURE_UNIT (ID_MEASURE_UNIT) 
;
ALTER TABLE SBI_KPI_INSTANCE_HISTORY ADD CONSTRAINT SBI_KPI_INSTANCE_HISTORY_2 FOREIGN KEY (THRESHOLD_ID) REFERENCES SBI_THRESHOLD (THRESHOLD_ID)
;
ALTER TABLE SBI_KPI_INSTANCE_HISTORY ADD CONSTRAINT SBI_KPI_INSTANCE_HISTORY_3 FOREIGN KEY (ID_KPI_INSTANCE) REFERENCES SBI_KPI_INSTANCE (ID_KPI_INSTANCE) 
;
ALTER TABLE SBI_KPI_MODEL_RESOURCES ADD CONSTRAINT SBI_KPI_MODEL_RESOURCES_1 FOREIGN KEY (KPI_MODEL_INST) REFERENCES SBI_KPI_MODEL_INST (KPI_MODEL_INST)
;
ALTER TABLE SBI_KPI_MODEL_RESOURCES ADD CONSTRAINT SBI_KPI_MODEL_RESOURCES_2 FOREIGN KEY (RESOURCE_ID) REFERENCES SBI_RESOURCES (RESOURCE_ID)
;
ALTER TABLE SBI_RESOURCES ADD CONSTRAINT SBI_RESOURCES_1 FOREIGN KEY (RESOURCE_TYPE_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_KPI_VALUE ADD CONSTRAINT SBI_KPI_VALUE_1 FOREIGN KEY (ID_KPI_INSTANCE) REFERENCES SBI_KPI_INSTANCE (ID_KPI_INSTANCE)
;
ALTER TABLE SBI_KPI_VALUE ADD CONSTRAINT SBI_KPI_VALUE_2 FOREIGN KEY (RESOURCE_ID) REFERENCES SBI_RESOURCES (RESOURCE_ID)
;
ALTER TABLE SBI_KPI_INST_PERIOD ADD CONSTRAINT SBI_KPI_INST_PERIOD_1 FOREIGN KEY  (KPI_INSTANCE_ID) REFERENCES SBI_KPI_INSTANCE (ID_KPI_INSTANCE)
;
ALTER TABLE SBI_KPI_INST_PERIOD ADD CONSTRAINT SBI_KPI_INST_PERIOD_2 FOREIGN KEY (PERIODICITY_ID) REFERENCES SBI_KPI_PERIODICITY (ID_KPI_PERIODICITY)
;
ALTER TABLE SBI_ALARM ADD CONSTRAINT SBI_ALARM_1 FOREIGN KEY (MODALITY_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_ALARM ADD CONSTRAINT SBI_ALARM_2 FOREIGN KEY (DOCUMENT_ID) REFERENCES SBI_OBJECTS (BIOBJ_ID)
;
ALTER TABLE SBI_ALARM ADD CONSTRAINT SBI_ALARM_3 FOREIGN KEY (ID_KPI_INSTANCE) REFERENCES SBI_KPI_INSTANCE (ID_KPI_INSTANCE) 
;
ALTER TABLE SBI_ALARM ADD CONSTRAINT SBI_ALARM_4 FOREIGN KEY (ID_THRESHOLD_VALUE) REFERENCES SBI_THRESHOLD_VALUE (ID_THRESHOLD_VALUE)
;
ALTER TABLE SBI_ALARM_EVENT ADD CONSTRAINT SBI_ALARM_EVENT_1 FOREIGN KEY (ALARM_ID) REFERENCES SBI_ALARM (ALARM_ID) ON DELETE CASCADE
;
ALTER TABLE SBI_ALARM_DISTRIBUTION ADD CONSTRAINT SBI_ALARM_DISTRIBUTION_1 FOREIGN KEY (ALARM_ID) REFERENCES SBI_ALARM (ALARM_ID)
;
ALTER TABLE SBI_ALARM_DISTRIBUTION ADD CONSTRAINT SBI_ALARM_DISTRIBUTION_2 FOREIGN KEY (ALARM_CONTACT_ID) REFERENCES SBI_ALARM_CONTACT (ALARM_CONTACT_ID)
;
ALTER TABLE SBI_KPI ADD CONSTRAINT SBI_KPI_11 FOREIGN KEY (KPI_TYPE) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_KPI ADD CONSTRAINT SBI_KPI_12 FOREIGN KEY (METRIC_SCALE_TYPE) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_KPI ADD CONSTRAINT SBI_KPI_13 FOREIGN KEY (MEASURE_TYPE) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_EXPORTERS ADD CONSTRAINT SBI_EXPORTERS_12 FOREIGN KEY (ENGINE_ID) REFERENCES SBI_ENGINES (ENGINE_ID)
;
ALTER TABLE SBI_EXPORTERS ADD CONSTRAINT SBI_EXPORTERS_13 FOREIGN KEY (DOMAIN_ID) REFERENCES SBI_DOMAINS (VALUE_ID)
;
ALTER TABLE SBI_OBJ_METADATA ADD CONSTRAINT FK_SBI_OBJ_METADATA_1 FOREIGN KEY ( DATA_TYPE_ID ) REFERENCES SBI_DOMAINS(VALUE_ID)
;
ALTER TABLE SBI_OBJ_METACONTENTS ADD CONSTRAINT FK_SBI_OBJ_METACONTENTS_1 FOREIGN KEY  ( OBJMETA_ID ) REFERENCES SBI_OBJ_METADATA (  OBJ_META_ID )
;
ALTER TABLE SBI_OBJ_METACONTENTS ADD CONSTRAINT FK_SBI_OBJ_METACONTENTS_2 FOREIGN KEY  ( BIOBJ_ID )   REFERENCES SBI_OBJECTS (  BIOBJ_ID )
;
ALTER TABLE SBI_OBJ_METACONTENTS ADD CONSTRAINT FK_SBI_OBJ_METACONTENTS_3 FOREIGN KEY  ( SUBOBJ_ID )  REFERENCES SBI_SUBOBJECTS (  SUBOBJ_ID )
;
ALTER TABLE SBI_OBJ_METACONTENTS ADD CONSTRAINT FK_SBI_OBJ_METACONTENTS_4 FOREIGN KEY  ( BIN_ID )     REFERENCES SBI_BINARY_CONTENTS(BIN_ID)
;
ALTER TABLE SBI_CONFIG ADD CONSTRAINT FK_SBI_CONFIG_1 FOREIGN KEY ( VALUE_TYPE_ID ) REFERENCES SBI_DOMAINS ( VALUE_ID )
;
ALTER TABLE SBI_USER_ATTRIBUTES ADD CONSTRAINT FK_SBI_USER_ATTRIBUTES_1 FOREIGN KEY (ID) REFERENCES SBI_USER (ID) 
;
ALTER TABLE SBI_EXT_USER_ROLES ADD CONSTRAINT FK_SBI_EXT_USER_ROLES_1 FOREIGN KEY (ID) REFERENCES SBI_USER (ID)
;
ALTER TABLE SBI_USER_ATTRIBUTES ADD CONSTRAINT FK_SBI_USER_ATTRIBUTES_2 FOREIGN KEY (ATTRIBUTE_ID) REFERENCES SBI_ATTRIBUTE (ATTRIBUTE_ID)
;
ALTER TABLE SBI_EXT_USER_ROLES ADD CONSTRAINT FK_SBI_EXT_USER_ROLES_2 FOREIGN KEY (EXT_ROLE_ID) REFERENCES SBI_EXT_ROLES (EXT_ROLE_ID)
;
ALTER TABLE SBI_KPI_ERROR ADD CONSTRAINT FK_SBI_KPI_ERROR_MODEL_1 FOREIGN KEY ( KPI_MODEL_INST_ID ) REFERENCES SBI_KPI_MODEL_INST ( KPI_MODEL_INST )
;
ALTER TABLE SBI_KPI_REL ADD CONSTRAINT FK_SBI_KPI_REL_3 FOREIGN KEY  ( KPI_FATHER_ID ) REFERENCES SBI_KPI ( KPI_ID );
;
ALTER TABLE SBI_KPI_REL ADD CONSTRAINT FK_SBI_KPI_REL_4 FOREIGN KEY ( KPI_CHILD_ID ) REFERENCES SBI_KPI ( KPI_ID );
;
ALTER TABLE SBI_ORG_UNIT_NODES ADD CONSTRAINT FK_SBI_ORG_UNIT_NODES_1 FOREIGN KEY ( OU_ID ) REFERENCES SBI_ORG_UNIT ( ID )
;
ALTER TABLE SBI_ORG_UNIT_NODES ADD CONSTRAINT FK_SBI_ORG_UNIT_NODES_2 FOREIGN KEY ( HIERARCHY_ID ) REFERENCES SBI_ORG_UNIT_HIERARCHIES ( ID ) ON DELETE CASCADE
;
ALTER TABLE SBI_ORG_UNIT_NODES ADD CONSTRAINT FK_SBI_ORG_UNIT_NODES_3 FOREIGN KEY ( PARENT_NODE_ID ) REFERENCES SBI_ORG_UNIT_NODES ( NODE_ID ) ON DELETE CASCADE
;
ALTER TABLE SBI_ORG_UNIT_GRANT ADD CONSTRAINT FK_SBI_ORG_UNIT_GRANT_2 FOREIGN KEY ( HIERARCHY_ID ) REFERENCES SBI_ORG_UNIT_HIERARCHIES ( ID )
;
ALTER TABLE SBI_ORG_UNIT_GRANT ADD CONSTRAINT FK_SBI_ORG_UNIT_GRANT_3 FOREIGN KEY ( KPI_MODEL_INST_NODE_ID ) REFERENCES SBI_KPI_MODEL_INST ( KPI_MODEL_INST )
;
ALTER TABLE SBI_ORG_UNIT_GRANT_NODES ADD CONSTRAINT FK_SBI_ORG_UNIT_GRANT_NODES_1 FOREIGN KEY ( NODE_ID ) REFERENCES SBI_ORG_UNIT_NODES ( NODE_ID ) ON DELETE CASCADE
;
ALTER TABLE SBI_ORG_UNIT_GRANT_NODES ADD CONSTRAINT FK_SBI_ORG_UNIT_GRANT_NODES_2 FOREIGN KEY ( KPI_MODEL_INST_NODE_ID ) REFERENCES SBI_KPI_MODEL_INST ( KPI_MODEL_INST ) ON DELETE CASCADE 
;
ALTER TABLE SBI_ORG_UNIT_GRANT_NODES ADD CONSTRAINT FK_SBI_ORG_UNIT_GRANT_NODES_3 FOREIGN KEY ( GRANT_ID ) REFERENCES SBI_ORG_UNIT_GRANT ( ID ) ON DELETE CASCADE
;

ALTER TABLE SBI_GOAL ADD CONSTRAINT FK_GRANT_ID_GRANT FOREIGN KEY  (GRANT_ID) REFERENCES SBI_ORG_UNIT_GRANT (ID) ON DELETE CASCADE
;
                
ALTER TABLE SBI_GOAL_HIERARCHY ADD CONSTRAINT FK_SBI_GOAL_HIERARCHY_GOAL FOREIGN KEY  (GOAL_ID) REFERENCES SBI_GOAL (GOAL_ID) ON DELETE CASCADE
;
ALTER TABLE SBI_GOAL_HIERARCHY ADD CONSTRAINT FK_SBI_GOAL_HIERARCHY_PARENT FOREIGN KEY  (PARENT_ID) REFERENCES SBI_GOAL_HIERARCHY (GOAL_HIERARCHY_ID) ON DELETE CASCADE
;
 
ALTER TABLE SBI_GOAL_KPI ADD CONSTRAINT FK_SBI_GOAL_KPI_GOAL FOREIGN KEY  (GOAL_HIERARCHY_ID) REFERENCES SBI_GOAL_HIERARCHY (GOAL_HIERARCHY_ID)  ON DELETE CASCADE
;
ALTER TABLE SBI_GOAL_KPI ADD CONSTRAINT FK_SBI_GOAL_KPI_KPI FOREIGN KEY  (KPI_INSTANCE_ID) REFERENCES SBI_KPI_MODEL_INST (KPI_MODEL_INST) ON DELETE CASCADE
;

ALTER TABLE SBI_OBJ_PARVIEW ADD CONSTRAINT FK_SBI_OBJ_PARVIEW_1 FOREIGN KEY ( OBJ_PAR_ID ) REFERENCES SBI_OBJ_PAR ( OBJ_PAR_ID ) 
;
ALTER TABLE SBI_OBJ_PARVIEW ADD CONSTRAINT FK_SBI_OBJ_PARVIEW_2 FOREIGN KEY ( OBJ_PAR_FATHER_ID ) REFERENCES SBI_OBJ_PAR ( OBJ_PAR_ID ) 
;

ALTER TABLE SBI_I18N_MESSAGES ADD CONSTRAINT FK_SBI_I18N_MESSAGES FOREIGN KEY (LANGUAGE_CD) REFERENCES SBI_DOMAINS(VALUE_ID)
;

ALTER TABLE SBI_KPI_COMMENTS ADD CONSTRAINT FK_SBI_KPI_COMMENT_1 FOREIGN KEY (BIN_ID) REFERENCES SBI_BINARY_CONTENTS (BIN_ID)
;
ALTER TABLE SBI_KPI_COMMENTS ADD CONSTRAINT FK_SBI_KPI_COMMENT_2 FOREIGN KEY (KPI_INST_ID) REFERENCES SBI_KPI_INSTANCE (ID_KPI_INSTANCE)
;

ALTER TABLE SBI_META_MODELS_VERSIONS ADD CONSTRAINT FK_SBI_META_MODELS_VERSIONS_1 FOREIGN KEY ( MODEL_ID ) REFERENCES SBI_META_MODELS( ID ) ON DELETE CASCADE
;

ALTER TABLE SBI_ARTIFACTS_VERSIONS ADD CONSTRAINT FK_SBI_ARTIFACTS_VERSIONS_1 FOREIGN KEY ( ARTIFACT_ID ) REFERENCES SBI_ARTIFACTS( ID ) ON DELETE CASCADE
;

ALTER TABLE SBI_META_MODELS ADD CONSTRAINT FK_SBIDATA_SOURCE FOREIGN KEY ( DATA_SOURCE_ID ) REFERENCES SBI_DATA_SOURCE( DS_ID )
;
COMMIT;